/**
 * freesewing | v0.25.0
 * A library for creating made-to-measure sewing patterns
 * (c) 2018 Joost De Cock <joost@decock.org> (https://github.com/joostdecock)
 * @license MIT
 */
var freesewing=function(){"use strict";function t(){this.list={}}function r(r,i){this.x=S(r),this.y=S(i),this.attributes=new t}function i(t,r){return t(r={exports:{}},r.exports),r.exports}t.prototype.add=function(t,r){return void 0===this.list[t]&&(this.list[t]=[]),this.list[t].push(r),this},t.prototype.set=function(t,r){return this.list[t]=[r],this},t.prototype.remove=function(t){return delete this.list[t],this},t.prototype.get=function(t){return void 0!==this.list[t]&&this.list[t].join(" ")},t.prototype.getAsArray=function(t){return void 0!==this.list[t]&&this.list[t]},t.prototype.render=function(){var t="";for(var r in this.list)t+=" "+r+'="'+this.list[r].join(" ")+'"';return t},t.prototype.renderAsCss=function(){var t="";for(var r in this.list)t+=" "+r+":"+this.list[r].join(" ")+";";return t},t.prototype.renderIfPrefixIs=function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:"",r="",i=t.length;for(var e in this.list)e.substr(0,i)===t&&(r+=" "+e.substr(i)+'="'+this.list[e].join(" ")+'"');return r},t.prototype.clone=function(){var r=new t;return r.list=JSON.parse(JSON.stringify(this.list)),r},r.prototype.rad2deg=function(t){return 57.29577951308232*t},r.prototype.deg2rad=function(t){return t/57.29577951308232},r.prototype.attr=function(t,r){return arguments.length>2&&void 0!==arguments[2]&&arguments[2]?this.attributes.set(t,r):this.attributes.add(t,r),this},r.prototype.dist=function(t){var r=this.x-t.x,i=this.y-t.y;return S(Math.sqrt(Math.pow(r,2)+Math.pow(i,2)))},r.prototype.slope=function(t){return(t.y-this.y)/(t.x-this.x)},r.prototype.dx=function(t){return t.x-this.x},r.prototype.dy=function(t){return t.y-this.y},r.prototype.angle=function(t){for(var r=Math.atan2(-1*this.dy(t),this.dx(t));r<0;)r+=2*Math.PI;return this.rad2deg(r)},r.prototype.rotate=function(t,i){var e=this.dist(i),n=this.angle(i);return new r(i.x+e*Math.cos(this.deg2rad(n+t))*-1,i.y+e*Math.sin(this.deg2rad(n+t)))},r.prototype.copy=function(){return new r(this.x,this.y)},r.prototype.flipX=function(){var t=arguments.length>0&&void 0!==arguments[0]&&arguments[0];return new r(!1===t?-1*this.x:t.x+this.dx(t),this.y)},r.prototype.flipY=function(){var t=arguments.length>0&&void 0!==arguments[0]&&arguments[0];return new r(this.x,!1===t?-1*this.y:t.y+this.dy(t))},r.prototype.shift=function(t,r){var i=this.copy();return i.x+=r,i.rotate(t,this)},r.prototype.shiftTowards=function(t,r){return this.shift(this.angle(t),r)},r.prototype.sitsOn=function(t){return this.x===t.x&&this.y===t.y},r.prototype.sitsRoughlyOn=function(t){return Math.round(this.x)===Math.round(t.x)&&Math.round(this.y)===Math.round(t.y)},r.prototype.shiftFractionTowards=function(t,r){return this.shiftTowards(t,this.dist(t)*r)},r.prototype.shiftOutwards=function(t,r){return this.shiftTowards(t,this.dist(t)+r)},r.prototype.clone=function(){var t=new r(this.x,this.y);return t.attributes=this.attributes.clone(),t},r.prototype.translate=function(t,r){var i=this.copy();return i.x+=t,i.y+=r,i};var e=i(function(t){var r,i,e,n,o,s,a,h,u,f,y,c,l,v;r=Math.abs,i=Math.cos,e=Math.sin,n=Math.acos,o=Math.atan2,s=Math.sqrt,a=Math.pow,h=function(t){return t<0?-a(-t,1/3):a(t,1/3)},u=Math.PI,f=2*u,y=u/2,c=Number.MAX_SAFE_INTEGER||9007199254740991,l=Number.MIN_SAFE_INTEGER||-9007199254740991,v={Tvalues:[-.06405689286260563,.06405689286260563,-.1911188674736163,.1911188674736163,-.3150426796961634,.3150426796961634,-.4337935076260451,.4337935076260451,-.5454214713888396,.5454214713888396,-.6480936519369755,.6480936519369755,-.7401241915785544,.7401241915785544,-.820001985973903,.820001985973903,-.8864155270044011,.8864155270044011,-.9382745520027328,.9382745520027328,-.9747285559713095,.9747285559713095,-.9951872199970213,.9951872199970213],Cvalues:[.12793819534675216,.12793819534675216,.1258374563468283,.1258374563468283,.12167047292780339,.12167047292780339,.1155056680537256,.1155056680537256,.10744427011596563,.10744427011596563,.09761865210411388,.09761865210411388,.08619016153195327,.08619016153195327,.0733464814110803,.0733464814110803,.05929858491543678,.05929858491543678,.04427743881741981,.04427743881741981,.028531388628933663,.028531388628933663,.0123412297999872,.0123412297999872],arcfn:function(t,r){var i=r(t),e=i.x*i.x+i.y*i.y;return void 0!==i.z&&(e+=i.z*i.z),s(e)},between:function(t,r,i){return r<=t&&t<=i||v.approximately(t,r)||v.approximately(t,i)},approximately:function(t,i,e){return r(t-i)<=(e||1e-6)},length:function(t){var r,i,e=0,n=v.Tvalues.length;for(r=0;r<n;r++)i=.5*v.Tvalues[r]+.5,e+=v.Cvalues[r]*v.arcfn(i,t);return.5*e},map:function(t,r,i,e,n){return e+(n-e)*((t-r)/(i-r))},lerp:function(t,r,i){var e={x:r.x+t*(i.x-r.x),y:r.y+t*(i.y-r.y)};return r.z&&i.z&&(e.z=r.z+t*(i.z-r.z)),e},pointToString:function(t){var r=t.x+"/"+t.y;return void 0!==t.z&&(r+="/"+t.z),r},pointsToString:function(t){return"["+t.map(v.pointToString).join(", ")+"]"},copy:function(t){return JSON.parse(JSON.stringify(t))},angle:function(t,r,i){var e=r.x-t.x,n=r.y-t.y,s=i.x-t.x,a=i.y-t.y;return o(e*a-n*s,e*s+n*a)},round:function(t,r){var i=""+t,e=i.indexOf(".");return parseFloat(i.substring(0,e+1+r))},dist:function(t,r){var i=t.x-r.x,e=t.y-r.y;return s(i*i+e*e)},closest:function(t,r){var i,e,n=a(2,63);return t.forEach(function(t,o){(e=v.dist(r,t))<n&&(n=e,i=o)}),{mdist:n,mpos:i}},abcratio:function(t,i){if(2!==i&&3!==i)return!1;if(void 0===t)t=.5;else if(0===t||1===t)return t;var e=a(t,i)+a(1-t,i);return r((e-1)/e)},projectionratio:function(t,r){if(2!==r&&3!==r)return!1;if(void 0===t)t=.5;else if(0===t||1===t)return t;var i=a(1-t,r);return i/(a(t,r)+i)},lli8:function(t,r,i,e,n,o,s,a){var h=(t-i)*(o-a)-(r-e)*(n-s);return 0!=h&&{x:((t*e-r*i)*(n-s)-(t-i)*(n*a-o*s))/h,y:((t*e-r*i)*(o-a)-(r-e)*(n*a-o*s))/h}},lli4:function(t,r,i,e){var n=t.x,o=t.y,s=r.x,a=r.y,h=i.x,p=i.y,u=e.x,f=e.y;return v.lli8(n,o,s,a,h,p,u,f)},lli:function(t,r){return v.lli4(t,t.c,r,r.c)},makeline:function(t,r){var i=p,e=t.x,n=t.y,o=r.x,s=r.y,a=(o-e)/3,h=(s-n)/3;return new i(e,n,e+a,n+h,e+2*a,n+2*h,o,s)},findbbox:function(t){var r=c,i=c,e=l,n=l;return t.forEach(function(t){var o=t.bbox();r>o.x.min&&(r=o.x.min),i>o.y.min&&(i=o.y.min),e<o.x.max&&(e=o.x.max),n<o.y.max&&(n=o.y.max)}),{x:{min:r,mid:(r+e)/2,max:e,size:e-r},y:{min:i,mid:(i+n)/2,max:n,size:n-i}}},shapeintersections:function(t,r,i,e,n){if(!v.bboxoverlap(r,e))return[];var o=[],s=[t.startcap,t.forward,t.back,t.endcap],a=[i.startcap,i.forward,i.back,i.endcap];return s.forEach(function(r){r.virtual||a.forEach(function(e){if(!e.virtual){var s=r.intersects(e,n);s.length>0&&(s.c1=r,s.c2=e,s.s1=t,s.s2=i,o.push(s))}})}),o},makeshape:function(t,r,i){var e=r.points.length,n=t.points.length,o=v.makeline(r.points[e-1],t.points[0]),s=v.makeline(t.points[n-1],r.points[0]),a={startcap:o,forward:t,back:r,endcap:s,bbox:v.findbbox([o,t,r,s])},h=v;return a.intersections=function(t){return h.shapeintersections(a,a.bbox,t,t.bbox,i)},a},getminmax:function(t,r,i){if(!i)return{min:0,max:0};var e,n,o=c,s=l;-1===i.indexOf(0)&&(i=[0].concat(i)),-1===i.indexOf(1)&&i.push(1);for(var a=0,h=i.length;a<h;a++)e=i[a],(n=t.get(e))[r]<o&&(o=n[r]),n[r]>s&&(s=n[r]);return{min:o,mid:(o+s)/2,max:s,size:s-o}},align:function(t,r){var n=r.p1.x,s=r.p1.y,a=-o(r.p2.y-s,r.p2.x-n);return t.map(function(t){return{x:(t.x-n)*i(a)-(t.y-s)*e(a),y:(t.x-n)*e(a)+(t.y-s)*i(a)}})},roots:function(t,r){r=r||{p1:{x:0,y:0},p2:{x:1,y:0}};var e=t.length-1,o=v.align(t,r),a=function(t){return 0<=t&&t<=1};if(2===e){if(0!==(d=(x=o[0].y)-2*(g=o[1].y)+(m=o[2].y))){var p=-s(g*g-x*m),u=-x+g;return[-(p+u)/d,-(-p+u)/d].filter(a)}return g!==m&&0===d?[(2*g-m)/2*(g-m)].filter(a):[]}var y=o[0].y,c=o[1].y,l=o[2].y,d=3*c-y-3*l+o[3].y,x=3*y-6*c+3*l,g=-3*y+3*c,m=y;if(v.approximately(d,0)){if(v.approximately(x,0))return v.approximately(g,0)?[]:[-m/g].filter(a);var b=2*x;return[((w=s(g*g-4*x*m))-g)/b,(-g-w)/b].filter(a)}var w,z,S=(o=(3*(g/=d)-(x/=d)*x)/3)/3,O=(w=(2*x*x*x-9*x*g+27*(m/=d))/27)/2,_=O*O+S*S*S;if(_<0){var M=-o/3,k=s(M*M*M),R=-w/(2*k),L=n(R<-1?-1:R>1?1:R),P=2*h(k);return[P*i(L/3)-x/3,P*i((L+f)/3)-x/3,P*i((L+2*f)/3)-x/3].filter(a)}if(0===_)return[2*(z=O<0?h(-O):-h(O))-x/3,-z-x/3].filter(a);var A=s(_);return[(z=h(-O+A))-h(O+A)-x/3].filter(a)},droots:function(t){if(3===t.length){var r=t[0],i=t[1],e=t[2],n=r-2*i+e;if(0!==n){var o=-s(i*i-r*e),a=-r+i;return[-(o+a)/n,-(-o+a)/n]}return i!==e&&0===n?[(2*i-e)/(2*(i-e))]:[]}if(2===t.length)return(r=t[0])!==(i=t[1])?[r/(r-i)]:[]},inflections:function(t){if(t.length<4)return[];var r=v.align(t,{p1:t[0],p2:t.slice(-1)[0]}),i=r[2].x*r[1].y,e=r[3].x*r[1].y,n=r[1].x*r[2].y,o=18*(-3*i+2*e+3*n-(f=r[3].x*r[2].y)),s=18*(3*i-e-3*n),a=18*(n-i);if(v.approximately(o,0)){if(!v.approximately(s,0)){var h=-a/s;if(0<=h&&h<=1)return[h]}return[]}var p=s*s-4*o*a,u=Math.sqrt(p),f=2*o;return v.approximately(f,0)?[]:[(u-s)/f,-(s+u)/f].filter(function(t){return 0<=t&&t<=1})},bboxoverlap:function(t,i){var e,n,o,s,a,h=["x","y"],p=h.length;for(e=0;e<p;e++)if(o=t[n=h[e]].mid,s=i[n].mid,a=(t[n].size+i[n].size)/2,r(o-s)>=a)return!1;return!0},expandbox:function(t,r){r.x.min<t.x.min&&(t.x.min=r.x.min),r.y.min<t.y.min&&(t.y.min=r.y.min),r.z&&r.z.min<t.z.min&&(t.z.min=r.z.min),r.x.max>t.x.max&&(t.x.max=r.x.max),r.y.max>t.y.max&&(t.y.max=r.y.max),r.z&&r.z.max>t.z.max&&(t.z.max=r.z.max),t.x.mid=(t.x.min+t.x.max)/2,t.y.mid=(t.y.min+t.y.max)/2,t.z&&(t.z.mid=(t.z.min+t.z.max)/2),t.x.size=t.x.max-t.x.min,t.y.size=t.y.max-t.y.min,t.z&&(t.z.size=t.z.max-t.z.min)},pairiteration:function(t,r,i){var e=t.bbox(),n=r.bbox(),o=1e5,s=i||.5;if(e.x.size+e.y.size<s&&n.x.size+n.y.size<s)return[(o*(t._t1+t._t2)/2|0)/o+"/"+(o*(r._t1+r._t2)/2|0)/o];var a=t.split(.5),h=r.split(.5),p=[{left:a.left,right:h.left},{left:a.left,right:h.right},{left:a.right,right:h.right},{left:a.right,right:h.left}];p=p.filter(function(t){return v.bboxoverlap(t.left.bbox(),t.right.bbox())});var u=[];return 0===p.length?u:(p.forEach(function(t){u=u.concat(v.pairiteration(t.left,t.right,s))}),u=u.filter(function(t,r){return u.indexOf(t)===r}))},getccenter:function(t,r,n){var s,a=r.x-t.x,h=r.y-t.y,p=n.x-r.x,u=n.y-r.y,c=a*i(y)-h*e(y),l=a*e(y)+h*i(y),d=p*i(y)-u*e(y),x=p*e(y)+u*i(y),g=(t.x+r.x)/2,m=(t.y+r.y)/2,b=(r.x+n.x)/2,w=(r.y+n.y)/2,z=g+c,S=m+l,O=b+d,_=w+x,M=v.lli8(g,m,z,S,b,w,O,_),k=v.dist(M,t),R=o(t.y-M.y,t.x-M.x),L=o(r.y-M.y,r.x-M.x),P=o(n.y-M.y,n.x-M.x);return R<P?((R>L||L>P)&&(R+=f),R>P&&(s=P,P=R,R=s)):P<L&&L<R?(s=P,P=R,R=s):P+=f,M.s=R,M.e=P,M.r=k,M},numberSort:function(t,r){return t-r}},t.exports=v}),n=i(function(t){var r,i;r=e,(i=function(t){this.curves=[],this._3d=!1,t&&(this.curves=t,this._3d=this.curves[0]._3d)}).prototype={valueOf:function(){return this.toString()},toString:function(){return"["+this.curves.map(function(t){return r.pointsToString(t.points)}).join(", ")+"]"},addCurve:function(t){this.curves.push(t),this._3d=this._3d||t._3d},length:function(){return this.curves.map(function(t){return t.length()}).reduce(function(t,r){return t+r})},curve:function(t){return this.curves[t]},bbox:function(){for(var t=this.curves,i=t[0].bbox(),e=1;e<t.length;e++)r.expandbox(i,t[e].bbox());return i},offset:function(t){var r=[];return this.curves.forEach(function(i){r=r.concat(i.offset(t))}),new i(r)}},t.exports=i});var o=function(t){var r,i,e,n,o,s,a=(t=t.replace(/,/g," ").replace(/-/g," - ").replace(/-\s+/g,"-").replace(/([a-zA-Z])/g," $1 ")).replace(/([a-zA-Z])\s?/g,"|$1").split("|"),h=a.length,p=[],u=0,f=0,y=0,c=0,l=0,v=0,d=0,x=0,g="";for(r=1;r<h;r++)if(n=(e=(i=a[r]).substring(0,1)).toLowerCase(),o=(p=(p=i.replace(e,"").trim().split(" ")).filter(function(t){return""!==t}).map(parseFloat)).length,"m"===n){if(g+="M ","m"===e?(y+=p[0],c+=p[1]):(y=p[0],c=p[1]),u=y,f=c,g+=y+" "+c+" ",o>2)for(s=0;s<o;s+=2)"m"===e?(y+=p[s],c+=p[s+1]):(y=p[s],c=p[s+1]),g+=["L",y,c,""].join(" ")}else if("l"===n)for(s=0;s<o;s+=2)"l"===e?(y+=p[s],c+=p[s+1]):(y=p[s],c=p[s+1]),g+=["L",y,c,""].join(" ");else if("h"===n)for(s=0;s<o;s++)"h"===e?y+=p[s]:y=p[s],g+=["L",y,c,""].join(" ");else if("v"===n)for(s=0;s<o;s++)"v"===e?c+=p[s]:c=p[s],g+=["L",y,c,""].join(" ");else if("q"===n)for(s=0;s<o;s+=4)"q"===e?(l=y+p[s],v=c+p[s+1],y+=p[s+2],c+=p[s+3]):(l=p[s],v=p[s+1],y=p[s+2],c=p[s+3]),g+=["Q",l,v,y,c,""].join(" ");else if("t"===n)for(s=0;s<o;s+=2)l=y+(y-l),v=c+(c-v),"t"===e?(y+=p[s],c+=p[s+1]):(y=p[s],c=p[s+1]),g+=["Q",l,v,y,c,""].join(" ");else if("c"===n)for(s=0;s<o;s+=6)"c"===e?(l=y+p[s],v=c+p[s+1],d=y+p[s+2],x=c+p[s+3],y+=p[s+4],c+=p[s+5]):(l=p[s],v=p[s+1],d=p[s+2],x=p[s+3],y=p[s+4],c=p[s+5]),g+=["C",l,v,d,x,y,c,""].join(" ");else if("s"===n)for(s=0;s<o;s+=4)l=y+(y-d),v=c+(c-x),"s"===e?(d=y+p[s],x=c+p[s+1],y+=p[s+2],c+=p[s+3]):(d=p[s],x=p[s+1],y=p[s+2],c=p[s+3]),g+=["C",l,v,d,x,y,c,""].join(" ");else"z"===n&&(g+="Z ",y=u,c=f);return g.trim()},s={x:!1,y:!1};function a(t,r,i){if("Z"!==r){if("M"!==r){var e=[!1,s.x,s.y].concat(i),n=new(t.bind.apply(t,e)),o=i.slice(-2);return s={x:o[0],y:o[1]},n}s={x:i[0],y:i[1]}}}var h=function(t,r){for(var i,e,n=o(r).split(" "),s=new RegExp("[MLCQZ]",""),h=[],p={C:6,Q:4,L:2,M:2};n.length;)i=n.splice(0,1)[0],s.test(i)&&(e=a(t,i,n.splice(0,p[i]).map(parseFloat)))&&h.push(e);return new t.PolyBezier(h)},p=i(function(t){!function(){var r=Math.abs,i=Math.min,o=Math.max,s=Math.cos,a=Math.sin,p=Math.acos,u=Math.sqrt,f=Math.PI,y={x:0,y:0,z:0},c=e,l=n,v=function(t){var i=t&&t.forEach?t:[].slice.call(arguments),e=!1;if("object"==typeof i[0]){e=i.length;var n=[];i.forEach(function(t){["x","y","z"].forEach(function(r){void 0!==t[r]&&n.push(t[r])})}),i=n}var o=!1,s=i.length;if(e){if(e>4){if(1!==arguments.length)throw new Error("Only new Bezier(point[]) is accepted for 4th and higher order curves");o=!0}}else if(6!==s&&8!==s&&9!==s&&12!==s&&1!==arguments.length)throw new Error("Only new Bezier(point[]) is accepted for 4th and higher order curves");var a=!o&&(9===s||12===s)||t&&t[0]&&void 0!==t[0].z;this._3d=a;for(var h=[],p=0,u=a?3:2;p<s;p+=u){var f={x:i[p],y:i[p+1]};a&&(f.z=i[p+2]),h.push(f)}this.order=h.length-1,this.points=h;var y=["x","y"];a&&y.push("z"),this.dims=y,this.dimlen=y.length,function(t){for(var i=t.order,e=t.points,n=c.align(e,{p1:e[0],p2:e[i]}),o=0;o<n.length;o++)if(r(n[o].y)>1e-4)return void(t._linear=!1);t._linear=!0}(this),this._t1=0,this._t2=1,this.update()},d=h;function x(t,r,i,e,n){void 0===n&&(n=.5);var o=c.projectionratio(n,t),s=1-o,a={x:o*r.x+s*e.x,y:o*r.y+s*e.y},h=c.abcratio(n,t);return{A:{x:i.x+(i.x-a.x)/h,y:i.y+(i.y-a.y)/h},B:i,C:a}}v.SVGtoBeziers=function(t){return d(v,t)},v.quadraticFromPoints=function(t,r,i,e){if(void 0===e&&(e=.5),0===e)return new v(r,r,i);if(1===e)return new v(t,r,r);var n=x(2,t,r,i,e);return new v(t,n.A,i)},v.cubicFromPoints=function(t,r,i,e,n){void 0===e&&(e=.5);var o=x(3,t,r,i,e);void 0===n&&(n=c.dist(r,o.C));var s=n*(1-e)/e,a=c.dist(t,i),h=(i.x-t.x)/a,p=(i.y-t.y)/a,u=n*h,f=n*p,y=s*h,l=s*p,d=r.x-u,g=r.y-f,m=r.x+y,b=r.y+l,w=o.A,z=w.x+(d-w.x)/(1-e),S=w.y+(g-w.y)/(1-e),O=w.x+(m-w.x)/e,_=w.y+(b-w.y)/e,M={x:t.x+(z-t.x)/e,y:t.y+(S-t.y)/e},k={x:i.x+(O-i.x)/(1-e),y:i.y+(_-i.y)/(1-e)};return new v(t,M,k,i)};var g=function(){return c};v.getUtils=g,v.PolyBezier=l,v.prototype={getUtils:g,valueOf:function(){return this.toString()},toString:function(){return c.pointsToString(this.points)},toSVG:function(t){if(this._3d)return!1;for(var r=this.points,i=["M",r[0].x,r[0].y,2===this.order?"Q":"C"],e=1,n=r.length;e<n;e++)i.push(r[e].x),i.push(r[e].y);return i.join(" ")},update:function(){this.dpoints=[];for(var t=this.points,r=t.length,i=r-1;r>1;r--,i--){for(var e,n=[],o=0;o<i;o++)e={x:i*(t[o+1].x-t[o].x),y:i*(t[o+1].y-t[o].y)},this._3d&&(e.z=i*(t[o+1].z-t[o].z)),n.push(e);this.dpoints.push(n),t=n}this.computedirection()},computedirection:function(){var t=this.points,r=c.angle(t[0],t[this.order],t[1]);this.clockwise=r>0},length:function(){return c.length(this.derivative.bind(this))},_lut:[],getLUT:function(t){if(t=t||100,this._lut.length===t)return this._lut;this._lut=[],t--;for(var r=0;r<=t;r++)this._lut.push(this.compute(r/t));return this._lut},on:function(t,r){r=r||5;for(var i,e=this.getLUT(),n=[],o=0,s=0;s<e.length;s++)i=e[s],c.dist(i,t)<r&&(n.push(i),o+=s/e.length);return!!n.length&&o/n.length},project:function(t){var r=this.getLUT(),i=r.length-1,e=c.closest(r,t),n=e.mdist,o=e.mpos;if(0===o||o===i){var s=o/i,a=this.compute(s);return a.t=s,a.d=n,a}var h,p,u,f=(o+1)/i,y=.1/i;for(n+=1,h=s=(o-1)/i;s<f+y;s+=y)p=this.compute(s),(u=c.dist(t,p))<n&&(n=u,h=s);return(p=this.compute(h)).t=h,p.d=n,p},get:function(t){return this.compute(t)},point:function(t){return this.points[t]},compute:function(t){if(0===t)return this.points[0];if(1===t)return this.points[this.order];var r=this.points,i=1-t;if(1===this.order)return p={x:i*r[0].x+t*r[1].x,y:i*r[0].y+t*r[1].y},this._3d&&(p.z=i*r[0].z+t*r[1].z),p;if(this.order<4){var e,n,o,s=i*i,a=t*t,h=0;2===this.order?(r=[r[0],r[1],r[2],y],e=s,n=i*t*2,o=a):3===this.order&&(e=s*i,n=s*t*3,o=i*a*3,h=t*a);var p={x:e*r[0].x+n*r[1].x+o*r[2].x+h*r[3].x,y:e*r[0].y+n*r[1].y+o*r[2].y+h*r[3].y};return this._3d&&(p.z=e*r[0].z+n*r[1].z+o*r[2].z+h*r[3].z),p}for(var u=JSON.parse(JSON.stringify(this.points));u.length>1;){for(var f=0;f<u.length-1;f++)u[f]={x:u[f].x+(u[f+1].x-u[f].x)*t,y:u[f].y+(u[f+1].y-u[f].y)*t},void 0!==u[f].z&&(u[f]=u[f].z+(u[f+1].z-u[f].z)*t);u.splice(u.length-1,1)}return u[0]},raise:function(){for(var t,r,i=this.points,e=[i[0]],n=i.length,o=1;o<n;o++)t=i[o],r=i[o-1],e[o]={x:(n-o)/n*t.x+o/n*r.x,y:(n-o)/n*t.y+o/n*r.y};return e[n]=i[n-1],new v(e)},derivative:function(t){var r,i,e=1-t,n=0,o=this.dpoints[0];2===this.order&&(o=[o[0],o[1],y],r=e,i=t),3===this.order&&(r=e*e,i=e*t*2,n=t*t);var s={x:r*o[0].x+i*o[1].x+n*o[2].x,y:r*o[0].y+i*o[1].y+n*o[2].y};return this._3d&&(s.z=r*o[0].z+i*o[1].z+n*o[2].z),s},inflections:function(){return c.inflections(this.points)},normal:function(t){return this._3d?this.__normal3(t):this.__normal2(t)},__normal2:function(t){var r=this.derivative(t),i=u(r.x*r.x+r.y*r.y);return{x:-r.y/i,y:r.x/i}},__normal3:function(t){var r=this.derivative(t),i=this.derivative(t+.01),e=u(r.x*r.x+r.y*r.y+r.z*r.z),n=u(i.x*i.x+i.y*i.y+i.z*i.z);r.x/=e,r.y/=e,r.z/=e,i.x/=n,i.y/=n,i.z/=n;var o={x:i.y*r.z-i.z*r.y,y:i.z*r.x-i.x*r.z,z:i.x*r.y-i.y*r.x},s=u(o.x*o.x+o.y*o.y+o.z*o.z);o.x/=s,o.y/=s,o.z/=s;var a=[o.x*o.x,o.x*o.y-o.z,o.x*o.z+o.y,o.x*o.y+o.z,o.y*o.y,o.y*o.z-o.x,o.x*o.z-o.y,o.y*o.z+o.x,o.z*o.z];return{x:a[0]*r.x+a[1]*r.y+a[2]*r.z,y:a[3]*r.x+a[4]*r.y+a[5]*r.z,z:a[6]*r.x+a[7]*r.y+a[8]*r.z}},hull:function(t){var r,i=this.points,e=[],n=[],o=0,s=0,a=0;for(n[o++]=i[0],n[o++]=i[1],n[o++]=i[2],3===this.order&&(n[o++]=i[3]);i.length>1;){for(e=[],s=0,a=i.length-1;s<a;s++)r=c.lerp(t,i[s],i[s+1]),n[o++]=r,e.push(r);i=e}return n},split:function(t,r){if(0===t&&r)return this.split(r).left;if(1===r)return this.split(t).right;var i=this.hull(t),e={left:2===this.order?new v([i[0],i[3],i[5]]):new v([i[0],i[4],i[7],i[9]]),right:2===this.order?new v([i[5],i[4],i[2]]):new v([i[9],i[8],i[6],i[3]]),span:i};return e.left._t1=c.map(0,0,1,this._t1,this._t2),e.left._t2=c.map(t,0,1,this._t1,this._t2),e.right._t1=c.map(t,0,1,this._t1,this._t2),e.right._t2=c.map(1,0,1,this._t1,this._t2),r?(r=c.map(r,t,1,0,1),e.right.split(r).left):e},extrema:function(){var t,r,i=this.dims,e={},n=[];return i.forEach(function(i){r=function(t){return t[i]},t=this.dpoints[0].map(r),e[i]=c.droots(t),3===this.order&&(t=this.dpoints[1].map(r),e[i]=e[i].concat(c.droots(t))),e[i]=e[i].filter(function(t){return t>=0&&t<=1}),n=n.concat(e[i].sort(c.numberSort))}.bind(this)),n=n.sort(c.numberSort).filter(function(t,r){return n.indexOf(t)===r}),e.values=n,e},bbox:function(){var t=this.extrema(),r={};return this.dims.forEach(function(i){r[i]=c.getminmax(this,i,t[i])}.bind(this)),r},overlaps:function(t){var r=this.bbox(),i=t.bbox();return c.bboxoverlap(r,i)},offset:function(t,r){if(void 0!==r){var i=this.get(t),e=this.normal(t),n={c:i,n:e,x:i.x+e.x*r,y:i.y+e.y*r};return this._3d&&(n.z=i.z+e.z*r),n}if(this._linear){var o=this.normal(0),s=this.points.map(function(r){var i={x:r.x+t*o.x,y:r.y+t*o.y};return r.z&&e.z&&(i.z=r.z+t*o.z),i});return[new v(s)]}return this.reduce().map(function(r){return r.scale(t)})},simple:function(){if(3===this.order){var t=c.angle(this.points[0],this.points[3],this.points[1]),i=c.angle(this.points[0],this.points[3],this.points[2]);if(t>0&&i<0||t<0&&i>0)return!1}var e=this.normal(0),n=this.normal(1),o=e.x*n.x+e.y*n.y;return this._3d&&(o+=e.z*n.z),r(p(o))<f/3},reduce:function(){var t,i,e=0,n=0,o=[],s=[],a=this.extrema().values;for(-1===a.indexOf(0)&&(a=[0].concat(a)),-1===a.indexOf(1)&&a.push(1),e=a[0],t=1;t<a.length;t++)n=a[t],(i=this.split(e,n))._t1=e,i._t2=n,o.push(i),e=n;return o.forEach(function(t){for(e=0,n=0;n<=1;)for(n=e+.01;n<=1.01;n+=.01)if(!(i=t.split(e,n)).simple()){if(r(e-(n-=.01))<.01)return[];(i=t.split(e,n))._t1=c.map(e,0,1,t._t1,t._t2),i._t2=c.map(n,0,1,t._t1,t._t2),s.push(i),e=n;break}e<1&&((i=t.split(e,1))._t1=c.map(e,0,1,t._t1,t._t2),i._t2=t._t2,s.push(i))}),s},scale:function(t){var r=this.order,i=!1;if("function"==typeof t&&(i=t),i&&2===r)return this.raise().scale(i);var e=this.clockwise,n=i?i(0):t,o=i?i(1):t,s=[this.offset(0,10),this.offset(1,10)],a=c.lli4(s[0],s[0].c,s[1],s[1].c);if(!a)throw new Error("cannot scale this curve. Try reducing it first.");var h=this.points,p=[];return[0,1].forEach(function(t){var i=p[t*r]=c.copy(h[t*r]);i.x+=(t?o:n)*s[t].n.x,i.y+=(t?o:n)*s[t].n.y}.bind(this)),i?([0,1].forEach(function(n){if(2!==this.order||!n){var o=h[n+1],s={x:o.x-a.x,y:o.y-a.y},f=i?i((n+1)/r):t;i&&!e&&(f=-f);var y=u(s.x*s.x+s.y*s.y);s.x/=y,s.y/=y,p[n+1]={x:o.x+f*s.x,y:o.y+f*s.y}}}.bind(this)),new v(p)):([0,1].forEach(function(t){if(2!==this.order||!t){var i=p[t*r],e=this.derivative(t),n={x:i.x+e.x,y:i.y+e.y};p[t+1]=c.lli4(i,n,a,h[t+1])}}.bind(this)),new v(p))},outline:function(t,r,i,e){r=void 0===r?t:r;var n,o=this.reduce(),s=o.length,a=[],h=[],p=0,u=this.length(),f=void 0!==i&&void 0!==e;function y(t,r,i,e,n){return function(o){var s=e/i,a=(e+n)/i,h=r-t;return c.map(o,0,1,t+s*h,t+a*h)}}o.forEach(function(n){z=n.length(),f?(a.push(n.scale(y(t,i,u,p,z))),h.push(n.scale(y(-r,-e,u,p,z)))):(a.push(n.scale(t)),h.push(n.scale(-r))),p+=z}),h=h.map(function(t){return(n=t.points)[3]?t.points=[n[3],n[2],n[1],n[0]]:t.points=[n[2],n[1],n[0]],t}).reverse();var v=a[0].points[0],d=a[s-1].points[a[s-1].points.length-1],x=h[s-1].points[h[s-1].points.length-1],g=h[0].points[0],m=c.makeline(x,v),b=c.makeline(d,g),w=[m].concat(a).concat([b]).concat(h),z=w.length;return new l(w)},outlineshapes:function(t,r,i){r=r||t;for(var e=this.outline(t,r).curves,n=[],o=1,s=e.length;o<s/2;o++){var a=c.makeshape(e[o],e[s-o],i);a.startcap.virtual=o>1,a.endcap.virtual=o<s/2-1,n.push(a)}return n},intersects:function(t,r){return t?t.p1&&t.p2?this.lineIntersects(t):(t instanceof v&&(t=t.reduce()),this.curveintersects(this.reduce(),t,r)):this.selfintersects(r)},lineIntersects:function(t){var r=i(t.p1.x,t.p2.x),e=i(t.p1.y,t.p2.y),n=o(t.p1.x,t.p2.x),s=o(t.p1.y,t.p2.y),a=this;return c.roots(this.points,t).filter(function(t){var i=a.get(t);return c.between(i.x,r,n)&&c.between(i.y,e,s)})},selfintersects:function(t){var r,i,e,n,o=this.reduce(),s=o.length-2,a=[];for(r=0;r<s;r++)e=o.slice(r,r+1),n=o.slice(r+2),i=this.curveintersects(e,n,t),a=a.concat(i);return a},curveintersects:function(t,r,i){var e=[];t.forEach(function(t){r.forEach(function(r){t.overlaps(r)&&e.push({left:t,right:r})})});var n=[];return e.forEach(function(t){var r=c.pairiteration(t.left,t.right,i);r.length>0&&(n=n.concat(r))}),n},arcs:function(t){t=t||.5;return this._iterate(t,[])},_error:function(t,i,e,n){var o=(n-e)/4,s=this.get(e+o),a=this.get(n-o),h=c.dist(t,i),p=c.dist(t,s),u=c.dist(t,a);return r(p-h)+r(u-h)},_iterate:function(t,r){var i,e=0,n=1;do{i=0,n=1;var o,h,p,u,f,y=this.get(e),l=!1,v=!1,d=n,x=1;do{if(v=l,u=p,d=(e+n)/2,o=this.get(d),h=this.get(n),(p=c.getccenter(y,o,h)).interval={start:e,end:n},l=this._error(p,y,e,n)<=t,(f=v&&!l)||(x=n),l){if(n>=1){if(p.interval.end=x=1,u=p,n>1){var g={x:p.x+p.r*s(p.e),y:p.y+p.r*a(p.e)};p.e+=c.angle({x:p.x,y:p.y},g,this.get(1))}break}n+=(n-e)/2}else n=d}while(!f&&i++<100);if(i>=100)break;u=u||p,r.push(u),e=x}while(n<1);return r}},t.exports=v}()}),u=p;function f(t){return t.charAt(0).toUpperCase()+t.slice(1)}function y(t){return"_macro_"+t}function c(t,i,e,n){var o=t.slope(i),s=e.slope(n);if(o===s)return!1;if(t.x===i.x)return new r(t.x,s*t.x+(e.y-s*e.x));if(e.x===n.x)return new r(e.x,o*e.x+(t.y-o*t.x));t.x>i.x&&(t=i.copy()),e.x>n.x&&(e=n.copy());var a=t.y-o*t.x,h=(e.y-s*e.x-a)/(o-s);return new r(h,o*h+a)}function l(t,r,i,e){var n=c(t,r,i,e);if(!n)return!1;var o=t.dist(r),s=i.dist(e),a=t.dist(n)+n.dist(r),h=i.dist(n)+n.dist(e);return Math.round(o)==Math.round(a)&&Math.round(s)==Math.round(h)&&n}function v(t,r,i){var e=arguments.length>3&&void 0!==arguments[3]?arguments[3]:1e6;if(t.sitsOn(i))return!0;if(r.sitsOn(i))return!0;var n=i.dx(t)*r.dy(t)-i.dy(t)*r.dx(t);return 0===Math.abs(Math.round(n*e)/e)}function d(t,r,i){if(!v(t,r,i,arguments.length>3&&void 0!==arguments[3]?arguments[3]:1e6))return!1;var e=t.dist(r),n=t.dist(i)+i.dist(r);return Math.round(e)==Math.round(n)}function x(t,r,i,e,n){if(t.sitsOn(n))return!0;if(e.sitsOn(n))return!0;var o=new u({x:t.x,y:t.y},{x:r.x,y:r.y},{x:i.x,y:i.y},{x:e.x,y:e.y}).intersects({p1:{x:n.x-1,y:n.y},p2:{x:n.x+1,y:n.y}});return o.length>0&&o.shift()}function g(t){return"imperial"===(arguments.length>1&&void 0!==arguments[1]?arguments[1]:"metric")?S(t/25.4)+'"':S(t/10)+"cm"}function m(t,i,e,n,o,s){var a=[],h=new u({x:e.x,y:e.y},{x:n.x,y:n.y},{x:o.x,y:o.y},{x:s.x,y:s.y}),p={p1:{x:t.x,y:t.y},p2:{x:i.x,y:i.y}},f=!0,y=!1,c=void 0;try{for(var l,v=h.intersects(p)[Symbol.iterator]();!(f=(l=v.next()).done);f=!0){var d=l.value,x=h.get(d);a.push(new r(x.x,x.y))}}catch(t){y=!0,c=t}finally{try{!f&&v.return&&v.return()}finally{if(y)throw c}}return 0!==a.length&&(1===a.length?a[0]:a)}function b(t,i,e,n,o,s,a,h){var p=[],f=new u({x:t.x,y:t.y},{x:i.x,y:i.y},{x:e.x,y:e.y},{x:n.x,y:n.y}),y=new u({x:o.x,y:o.y},{x:s.x,y:s.y},{x:a.x,y:a.y},{x:h.x,y:h.y}),c=!0,l=!1,v=void 0;try{for(var d,x=f.intersects(y,.005)[Symbol.iterator]();!(c=(d=x.next()).done);c=!0){var g=d.value,m=f.get(g.substr(0,g.indexOf("/")));p.push(new r(m.x,m.y))}}catch(t){l=!0,v=t}finally{try{!c&&x.return&&x.return()}finally{if(l)throw v}}if(0===p.length)return!1;if(1===p.length)return p.shift();var b=[],w=!0,z=!1,S=void 0;try{for(var O,_=p[Symbol.iterator]();!(w=(O=_.next()).done);w=!0){var M=O.value,k=!1,R=!0,L=!1,P=void 0;try{for(var A,j=b[Symbol.iterator]();!(R=(A=j.next()).done);R=!0){var I=A.value;M.sitsRoughlyOn(I)&&(k=!0)}}catch(t){L=!0,P=t}finally{try{!R&&j.return&&j.return()}finally{if(L)throw P}}k||b.push(M)}}catch(t){z=!0,S=t}finally{try{!w&&_.return&&_.return()}finally{if(z)throw S}}return b}function w(t,i,e,n){var o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:"x",s=n.x-e.x,a=n.y-e.y,h=Math.pow(s,2)+Math.pow(a,2),p=2*(s*(e.x-t.x)+a*(e.y-t.y)),u=Math.pow(e.x-t.x,2)+Math.pow(e.y-t.y,2)-Math.pow(i,2),f=Math.pow(p,2)-4*h*u;if(h<=1e-7||f<0)return!1;if(0===f){var y=-1*p/(2*h);return[new r(e.x+y*s,e.y+y*a)]}var c=(-1*p+Math.sqrt(f))/(2*h),l=new r(e.x+c*s,e.y+c*a);c=(-1*p-Math.sqrt(f))/(2*h);var v=new r(e.x+c*s,e.y+c*a);return"x"===o&&l.x<=v.x||"y"===o&&l.y<=v.y?[l,v]:[v,l]}function z(t,i){var e=arguments.length>2&&void 0!==arguments[2]?arguments[2]:500,n=1/0,o=1/0,s=void 0;"bottom"===i&&(o=-1/0),"right"===i&&(n=-1/0);for(var a=0;a<e;a++)s=t.get(a/e),("top"===i&&s.y<o||"bottom"===i&&s.y>o||"right"===i&&s.x>n||"left"===i&&s.x<n)&&(n=s.x,o=s.y);return new r(n,o)}function S(t){return Math.round(100*t)/100}function O(t,r){return"stroke: hsl("+330/r*(t-1)+", 100%, 35%);"}var _=Object.freeze({capitalize:f,macroName:y,beamsIntersect:c,linesIntersect:l,pointOnBeam:v,pointOnLine:d,pointOnCurve:x,beamIntersectsX:function(t,i,e){return t.x!==i.x&&c(t,i,new r(e,-10),new r(e,10))},beamIntersectsY:function(t,i,e){return t.y!==i.y&&c(t,i,new r(-10,e),new r(10,e))},units:g,lineIntersectsCurve:m,curvesIntersect:b,circlesIntersect:function(t,i,e,n){var o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:"x",s=t.dx(e),a=t.dy(e),h=t.dist(e);if(h>parseFloat(i)+parseFloat(n))return!1;if(h<parseFloat(n)-parseFloat(i))return!1;if(0===h&&i===n)return!1;var p=(Math.pow(i,2)-Math.pow(n,2)+Math.pow(h,2))/(2*h),u=Math.sqrt(Math.pow(i,2)-Math.pow(p,2)),f=t.x+p*s/h,y=t.y+p*a/h,c=new r(f+u*a/h,y-u*s/h),l=new r(f-u*a/h,y+u*s/h);return"x"===o&&c.x<=l.x||"y"===o&&c.y<=l.y?[c,l]:[l,c]},beamIntersectsCircle:w,lineIntersectsCircle:function(t,r,i,e){var n=arguments.length>4&&void 0!==arguments[4]?arguments[4]:"x",o=w(t,r,i,e,n);if(!1===o)return!1;if(1===o.length)return!!d(i,e,o[0])&&o;var s=o[0],a=o[1];return!(!d(i,e,s,5)&&!d(i,e,a,5))&&(d(i,e,s,5)&&d(i,e,a,5)?"x"===n&&s.x<=a.x||"y"===n&&s.y<=a.y?[s,a]:[a,s]:d(i,e,s,5)?[s]:d(i,e,a,5)?[a]:void 0)},curveEdge:z,stretchToScale:function(t){return 1/(1+parseFloat(t))},round:S,sampleStyle:O}),M="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t},k=Object.assign||function(t){for(var r=1;r<arguments.length;r++){var i=arguments[r];for(var e in i)Object.prototype.hasOwnProperty.call(i,e)&&(t[e]=i[e])}return t};function R(){this.render=!0,this.topLeft=!1,this.bottomRight=!1,this.attributes=new t,this.ops=[]}function L(t,r,i){if(t.x===r.x&&t.y===r.y)return!1;var e=t.angle(r)-90;return(new R).move(t.shift(e,i)).line(r.shift(e,i))}function P(t){return(new R).move(new r(t.points[0].x,t.points[0].y)).curve(new r(t.points[1].x,t.points[1].y),new r(t.points[2].x,t.points[2].y),new r(t.points[3].x,t.points[3].y))}function A(t){var r=arguments.length>1&&void 0!==arguments[1]&&arguments[1],i=(new R).move(t[0].ops[0].to),e=void 0,n=!0,o=!1,s=void 0;try{for(var a,h=t[Symbol.iterator]();!(n=(a=h.next()).done);n=!0){var p=a.value,u=!0,f=!1,y=void 0;try{for(var c,l=p.ops[Symbol.iterator]();!(u=(c=l.next()).done);u=!0){var v=c.value;if("curve"===v.type)i.curve(v.cp1,v.cp2,v.to);else{if("close"===v.type)throw"Cannot join a closed paths with another";e&&!v.to.sitsRoughlyOn(e)&&i.line(v.to)}v.to&&(e=v.to)}}catch(t){f=!0,y=t}finally{try{!u&&l.return&&l.return()}finally{if(f)throw y}}}}catch(t){o=!0,s=t}finally{try{!n&&h.return&&h.return()}finally{if(o)throw s}}return r&&i.close(),i}function j(t,i){for(var e=void 0,n=void 0,o=void 0,s=void 0,a=0,h=0;h<=100;h++){if(o=h/100,n=new r((n=i.get(o)).x,n.y),h>0){if(a+(s=n.dist(e))>t)return n;a+=s}e=n}}function I(t){var i=t.from,e=t.to;return i.x===e.x?i.y<e.y?{topLeft:i,bottomRight:e}:{topLeft:e,bottomRight:i}:i.y===e.y?i.x<e.x?{topLeft:i,bottomRight:e}:{topLeft:e,bottomRight:i}:i.x<e.x?i.y<e.y?{topLeft:i,bottomRight:e}:{topLeft:new r(i.x,e.y),bottomRight:new r(e.x,i.y)}:i.x>e.x?i.y<e.y?{topLeft:new r(e.x,i.y),bottomRight:new r(i.x,e.y)}:{topLeft:new r(e.x,e.y),bottomRight:new r(i.x,i.y)}:void 0}function T(t,r){if(t&&"object"===(void 0===t?"undefined":M(t)))if("number"==typeof t.x)r.push(t);else{var i=!0,e=!1,n=void 0;try{for(var o,s=t[Symbol.iterator]();!(i=(o=s.next()).done);i=!0){var a=o.value;r.push(a)}}catch(t){e=!0,n=t}finally{try{!i&&s.return&&s.return()}finally{if(e)throw n}}}}function C(r,i){return this.def=r,this.anchor=i,this.attributes=new t,this}R.prototype.move=function(t){return this.ops.push({type:"move",to:t}),this},R.prototype.line=function(t){return this.ops.push({type:"line",to:t}),this},R.prototype.curve=function(t,r,i){return this.ops.push({type:"curve",cp1:t,cp2:r,to:i}),this},R.prototype._curve=function(t,r){var i=this.ops.slice(-1).pop().to;return this.ops.push({type:"curve",cp1:i,cp2:t,to:r}),this},R.prototype.curve_=function(t,r){var i=r.copy();return this.ops.push({type:"curve",cp1:t,cp2:i,to:r}),this},R.prototype.close=function(){return this.ops.push({type:"close"}),this},R.prototype.attr=function(t,r){return arguments.length>2&&void 0!==arguments[2]&&arguments[2]?this.attributes.set(t,r):this.attributes.add(t,r),this},R.prototype.asPathstring=function(){var t="",r=!0,i=!1,e=void 0;try{for(var n,o=this.ops[Symbol.iterator]();!(r=(n=o.next()).done);r=!0){var s=n.value;switch(s.type){case"move":t+="M "+s.to.x+","+s.to.y;break;case"line":t+=" L "+s.to.x+","+s.to.y;break;case"curve":t+=" C "+s.cp1.x+","+s.cp1.y+" "+s.cp2.x+","+s.cp2.y+" "+s.to.x+","+s.to.y;break;case"close":t+=" z"}}}catch(t){i=!0,e=t}finally{try{!r&&o.return&&o.return()}finally{if(i)throw e}}return t},R.prototype.offset=function(t){return function(t,r){var i=[],e=void 0,n=!1;for(var o in t.ops){var s=t.ops[o];if("line"===s.type){var a=L(e,s.to,r);a&&i.push(a)}else if("curve"===s.type){var h=void 0,p=void 0;h=e.sitsRoughlyOn(s.cp1)?(new R).move(e).curve(s.cp1,s.cp2,s.to).shiftAlong(2):s.cp1,p=s.cp2.sitsRoughlyOn(s.to)?(new R).move(s.to).curve(s.cp2,s.cp1,e).shiftAlong(2):s.cp2;var f=new u({x:e.x,y:e.y},{x:h.x,y:h.y},{x:p.x,y:p.y},{x:s.to.x,y:s.to.y}),y=!0,c=!1,l=void 0;try{for(var v,d=f.offset(r)[Symbol.iterator]();!(y=(v=d.next()).done);y=!0){var x=v.value;i.push(P(x))}}catch(t){c=!0,l=t}finally{try{!y&&d.return&&d.return()}finally{if(c)throw l}}}else"close"===s.type&&(n=!0);s.to&&(e=s.to)}return A(i,n)}(this,t)},R.prototype.length=function(){var t=void 0,r=void 0,i=0;for(var e in this.ops){var n=this.ops[e];"move"===n.type?r=n.to:"line"===n.type?i+=t.dist(n.to):"curve"===n.type?i+=new u({x:t.x,y:t.y},{x:n.cp1.x,y:n.cp1.y},{x:n.cp2.x,y:n.cp2.y},{x:n.to.x,y:n.to.y}).length():"close"===n.type&&(i+=t.dist(r)),n.to&&(t=n.to)}return S(i)},R.prototype.start=function(){return this.ops[0].to},R.prototype.end=function(){var t=this.ops[this.ops.length-1];return"close"===t.type?this.start():t.to},R.prototype.boundary=function(){if(this.topLeft)return this;var t=void 0,i=new r(1/0,1/0),e=new r(-1/0,-1/0),n=[];for(var o in this.ops){var s=this.ops[o];if("move"===s.type||"line"===s.type)s.to.x<i.x&&(i.x=s.to.x,n.leftOp=o),s.to.y<i.y&&(i.y=s.to.y,n.topOp=o),s.to.x>e.x&&(e.x=s.to.x,n.rightOp=o),s.to.y>e.y&&(e.y=s.to.y,n.bottomOp=o);else if("curve"===s.type){var a=new u({x:t.x,y:t.y},{x:s.cp1.x,y:s.cp1.y},{x:s.cp2.x,y:s.cp2.y},{x:s.to.x,y:s.to.y}).bbox();a.x.min<i.x&&(i.x=a.x.min,n.leftOp=o),a.y.min<i.y&&(i.y=a.y.min,n.topOp=o),a.x.max>e.x&&(e.x=a.x.max,n.rightOp=o),a.y.max>e.y&&(e.y=a.y.max,n.bottomOp=o)}s.to&&(t=s.to)}this.topLeft=i,this.bottomRight=e;for(var h=["top","left","bottom","right"],p=0;p<h.length;p++){var f=h[p]+"Op";this[f]=this.ops[n[f]],this[f].from="move"===this[f].type?this[f].to:this.ops[n[f]-1].to}return this},R.prototype.clone=function(){var t=new R;for(var r in t.render=this.render,this.topLeft?t.topLeft=this.topLeft.clone():t.topLeft=!1,this.bottomRight?t.bottomRight=this.bottomRight.clone():t.bottomRight=!1,t.attributes=this.attributes.clone(),t.ops=[],this.ops){var i=this.ops[r];t.ops[r]={type:i.type},"move"===i.type||"line"===i.type?t.ops[r].to=i.to.clone():"curve"===i.type&&(t.ops[r].to=i.to.clone(),t.ops[r].cp1=i.cp1.clone(),t.ops[r].cp2=i.cp2.clone())}return t},R.prototype.join=function(t){return A([this,t],arguments.length>1&&void 0!==arguments[1]&&arguments[1])},R.prototype.shiftAlong=function(t){var r=0,i=void 0;for(var e in this.ops){var n=this.ops[e];if("line"===n.type){var o=n.to.dist(i);if(r+o>t)return i.shiftTowards(n.to,t-r);r+=o}else if("curve"===n.type){var s=new u({x:i.x,y:i.y},{x:n.cp1.x,y:n.cp1.y},{x:n.cp2.x,y:n.cp2.y},{x:n.to.x,y:n.to.y}),a=s.length();if(r+a>t)return j(t-r,s);r+=a}i=n.to}throw"Ran out of path to shift along"},R.prototype.shiftFractionAlong=function(t){return this.shiftAlong(this.length()*t)},R.prototype.bbox=function(){var t,i,e=[],n=void 0;for(var o in this.ops){var s=this.ops[o];"line"===s.type?e.push(I({from:n,to:s.to})):"curve"===s.type&&e.push((t=new u({x:n.x,y:n.y},{x:s.cp1.x,y:s.cp1.y},{x:s.cp2.x,y:s.cp2.y},{x:s.to.x,y:s.to.y}),void 0,{topLeft:new r((i=t.bbox()).x.min,i.y.min),bottomRight:new r(i.x.max,i.y.max)})),s.to&&(n=s.to)}return function(t){var i=1/0,e=-1/0,n=1/0,o=-1/0,s=!0,a=!1,h=void 0;try{for(var p,u=t[Symbol.iterator]();!(s=(p=u.next()).done);s=!0){var f=p.value;f.topLeft.x<i&&(i=f.topLeft.x),f.topLeft.y<n&&(n=f.topLeft.y),f.bottomRight.x>e&&(e=f.bottomRight.x),f.bottomRight.y>o&&(o=f.bottomRight.y)}}catch(t){a=!0,h=t}finally{try{!s&&u.return&&u.return()}finally{if(a)throw h}}return{topLeft:new r(i,n),bottomRight:new r(e,o)}}(e)},R.prototype.reverse=function(){var t=[],r=void 0,i=!1;for(var e in this.ops){var n=this.ops[e];"line"===n.type?n.to.sitsOn(r)||t.push((new R).move(n.to).line(r)):"curve"===n.type?t.push((new R).move(n.to).curve(n.cp2,n.cp1,r)):"close"===n.type&&(i=!0),n.to&&(r=n.to)}var o=(new R).move(r),s=!0,a=!1,h=void 0;try{for(var p,u=t.reverse()[Symbol.iterator]();!(s=(p=u.next()).done);s=!0){var f=p.value;o.ops.push(f.ops[1])}}catch(t){a=!0,h=t}finally{try{!s&&u.return&&u.return()}finally{if(a)throw h}}return i&&o.close(),o},R.prototype.edge=function(t){if(this.boundary(),"topLeft"===t)return this.topLeft;if("bottomRight"===t)return this.bottomRight;if("topRight"===t)return new r(this.bottomRight.x,this.topLeft.y);if("bottomLeft"===t)return new r(this.topLeft.x,this.bottomRight.y);var i,e=t+"Op";if("move"===this[e].type)return this[e].to;if("line"===this[e].type){if("top"===t)return this.topOp.to.y<this.topOp.from.y?this.topOp.to:this.topOp.from;if("left"===t)return this.leftOp.to.x<this.leftOp.from.x?this.leftOp.to:this.leftOp.from;if("bottom"===t)return this.bottomOp.to.y>this.bottomOp.from.y?this.bottomOp.to:this.bottomOp.from;if("right"===t)return this.rightOp.to.x>this.rightOp.from.x?this.rightOp.to:this.rightOp.from}else if("curve"===this[e].type){return z((i=this[e],new u({x:i.from.x,y:i.from.y},{x:i.cp1.x,y:i.cp1.y},{x:i.cp2.x,y:i.cp2.y},{x:i.to.x,y:i.to.y})),t)}},R.prototype.divide=function(){var t=[],r=void 0,i=void 0;for(var e in this.ops){var n=this.ops[e];"move"===n.type?i=n.to:"line"===n.type?n.to.sitsRoughlyOn(r)||t.push((new R).move(r).line(n.to)):"curve"===n.type?t.push((new R).move(r).curve(n.cp1,n.cp2,n.to)):"close"===n.type&&t.push((new R).move(r).line(i)),n.to&&(r=n.to)}return t},R.prototype.intersectsX=function(t){return this.intersectsAxis(t,"x")},R.prototype.intersectsY=function(t){return this.intersectsAxis(t,"y")},R.prototype.intersectsAxis=function(){var t=arguments.length>0&&void 0!==arguments[0]&&arguments[0],i=arguments[1];if(!1===t)throw"Path.intersects[X-Y] requires an value as parameter";var e=[],n="x"===i?new r(t,-1e5):new r(-1e4,t),o="x"===i?new r(t,1e5):new r(1e5,t),s=!0,a=!1,h=void 0;try{for(var p,u=this.divide()[Symbol.iterator]();!(s=(p=u.next()).done);s=!0){var f=p.value;"line"===f.ops[1].type?T(l(f.ops[0].to,f.ops[1].to,n,o),e):"curve"===f.ops[1].type&&T(m(n,o,f.ops[0].to,f.ops[1].cp1,f.ops[1].cp2,f.ops[1].to),e)}}catch(t){a=!0,h=t}finally{try{!s&&u.return&&u.return()}finally{if(a)throw h}}return e},R.prototype.intersects=function(t){if(this===t)throw"Calculating intersections between two identical paths is bad idea";var r=[],i=!0,e=!1,n=void 0;try{for(var o,s=this.divide()[Symbol.iterator]();!(i=(o=s.next()).done);i=!0){var a=o.value,h=!0,p=!1,u=void 0;try{for(var f,y=t.divide()[Symbol.iterator]();!(h=(f=y.next()).done);h=!0){var c=f.value;"line"===a.ops[1].type?"line"===c.ops[1].type?T(l(a.ops[0].to,a.ops[1].to,c.ops[0].to,c.ops[1].to),r):"curve"===c.ops[1].type&&T(m(a.ops[0].to,a.ops[1].to,c.ops[0].to,c.ops[1].cp1,c.ops[1].cp2,c.ops[1].to),r):"curve"===a.ops[1].type&&("line"===c.ops[1].type?T(m(c.ops[0].to,c.ops[1].to,a.ops[0].to,a.ops[1].cp1,a.ops[1].cp2,a.ops[1].to),r):"curve"===c.ops[1].type&&T(b(a.ops[0].to,a.ops[1].cp1,a.ops[1].cp2,a.ops[1].to,c.ops[0].to,c.ops[1].cp1,c.ops[1].cp2,c.ops[1].to),r))}}catch(t){p=!0,u=t}finally{try{!h&&y.return&&y.return()}finally{if(p)throw u}}}}catch(t){e=!0,n=t}finally{try{!i&&s.return&&s.return()}finally{if(e)throw n}}return r},R.prototype.split=function(t){var i=this.divide(),e=!1,n=!1;for(var o in i){var s=i[o];if("line"===s.ops[1].type)d(s.ops[0].to,s.ops[1].to,t)&&((e=i.slice(0,o)).push((new R).move(s.ops[0].to).line(t)),o++,(n=i.slice(o)).unshift((new R).move(t).line(s.ops[1].to)));else if("curve"===s.ops[1].type){var a=x(s.ops[0].to,s.ops[1].cp1,s.ops[1].cp2,s.ops[1].to,t);if(!1!==a){var h=new u({x:s.ops[0].to.x,y:s.ops[0].to.y},{x:s.ops[1].cp1.x,y:s.ops[1].cp1.y},{x:s.ops[1].cp2.x,y:s.ops[1].cp2.y},{x:s.ops[1].to.x,y:s.ops[1].to.y}).split(a);(e=i.slice(0,o)).push((new R).move(new r(h.left.points[0].x,h.left.points[0].y)).curve(new r(h.left.points[1].x,h.left.points[1].y),new r(h.left.points[2].x,h.left.points[2].y),new r(h.left.points[3].x,h.left.points[3].y))),o++,(n=i.slice(o)).unshift((new R).move(new r(h.right.points[0].x,h.right.points[0].y)).curve(new r(h.right.points[1].x,h.right.points[1].y),new r(h.right.points[2].x,h.right.points[2].y),new r(h.right.points[3].x,h.right.points[3].y)))}}}return e&&(e=A(e)),n&&(n=A(n)),[e,n]},R.prototype.trim=function(){var t=this.divide();for(var i in t)for(var e=parseInt(i)+2,n=parseInt(t.length)-1,o=e;o<n;o++){var s=t[i].intersects(t[o]);if(s.length>0){for(var a=s.pop(),h=t.slice(0,i),p=t.slice(parseInt(o)+1),f=new R,y=!0,c=[i,o],l=0;l<c.length;l++){var v=t[c[l]].ops;if("line"===v[1].type)f.line(a);else if("curve"===v[1].type){var d=new u({x:v[0].to.x,y:v[0].to.y},{x:v[1].cp1.x,y:v[1].cp1.y},{x:v[1].cp2.x,y:v[1].cp2.y},{x:v[1].to.x,y:v[1].to.y}),g=x(v[0].to,v[1].cp1,v[1].cp2,v[1].to,a),m=d.split(g),b=void 0;b=y?m.left:m.right,f.curve(new r(b.points[1].x,b.points[1].y),new r(b.points[2].x,b.points[2].y),new r(b.points[3].x,b.points[3].y))}y=!1}var w=void 0;return w=h.length>0?A(h).join(f):f,p.length>0&&(w=w.join(A(p))),w.trim()}}return this},R.prototype.translate=function(t,r){var i=this.clone(),e=!0,n=!1,o=void 0;try{for(var s,a=i.ops[Symbol.iterator]();!(e=(s=a.next()).done);e=!0){var h=s.value;"close"!==h.type&&(h.to=h.to.translate(t,r)),"curve"===h.type&&(h.cp1=h.cp1.translate(t,r),h.cp2=h.cp2.translate(t,r))}}catch(t){n=!0,o=t}finally{try{!e&&a.return&&a.return()}finally{if(n)throw o}}return i},C.prototype.attr=function(t,r){return arguments.length>2&&void 0!==arguments[2]&&arguments[2]?this.attributes.set(t,r):this.attributes.add(t,r),this},C.prototype.clone=function(){var t=new C(this.def,this.anchor.clone());return t.attributes=this.attributes.clone(),t};var E={preDraft:[],postDraft:[],preSample:[],postSample:[],preRender:[],postRender:[],insertText:[],debug:[]};function N(){return this.attributes=new t,this.points={},this.paths={},this.snippets={},this.freeId=0,this.topLeft=!1,this.bottomRight=!1,this.width=!1,this.height=!1,this.render=!0,this.utils=_,this.Point=r,this.Path=R,this.Snippet=C,this.hooks=E,this}N.prototype.macroClosure=function(t){var r=this;return function(t,i){var e=y(t);"function"==typeof r[e]?r[e](i):r.debug({type:"warning",label:"🚨 Macro not found",msg:"Macro "+t+" is not registered"})}},N.prototype.debugClosure=function(){var t=this;return function(r){t.debug(r)}},N.prototype.runHooks=function(t){var r=arguments.length>1&&void 0!==arguments[1]&&arguments[1];!1===r&&(r=this);var i=this.hooks[t];if(i.length>0){var e=!0,n=!1,o=void 0;try{for(var s,a=i[Symbol.iterator]();!(e=(s=a.next()).done);e=!0){var h=s.value;h.method(r,h.data)}}catch(t){n=!0,o=t}finally{try{!e&&a.return&&a.return()}finally{if(n)throw o}}}},N.prototype.debug=function(t){this.runHooks("debug",t)},N.prototype.getId=function(){return this.freeId+=1,""+this.freeId},N.prototype.unitsClosure=function(t){var r=this;return function(t){return g(t,r.context.settings.units)}},N.prototype.boundary=function(){if(this.topLeft)return this;var t=new r(1/0,1/0),i=new r(-1/0,-1/0);for(var e in this.paths){var n=this.paths[e].boundary();n.render&&(n.topLeft.x<t.x&&(t.x=n.topLeft.x),n.topLeft.y<t.y&&(t.y=n.topLeft.y),n.bottomRight.x>i.x&&(i.x=n.bottomRight.x),n.bottomRight.y>i.y&&(i.y=n.bottomRight.y))}for(var o in this.points){var s=this.points[o],a=s.attributes.get("data-circle");a&&(a=parseFloat(a),s.x-a<t.x&&(t.x=s.x-a),s.y-a<t.y&&(t.y=s.y-a),s.x+a>i.x&&(i.x=s.x+a),s.y+a>i.y&&(i.y=s.y+a))}t.x===1/0&&(t.x=0),t.y===1/0&&(t.y=0),i.x===-1/0&&(i.x=0),i.y===-1/0&&(i.y=0);var h=this.context.settings.margin;return this.context.settings.paperless&&h<10&&(h=10),this.topLeft=new r(t.x-h,t.y-h),this.bottomRight=new r(i.x+h,i.y+h),this.width=this.bottomRight.x-this.topLeft.x,this.height=this.bottomRight.y-this.topLeft.y,this},N.prototype.stack=function(){return!1!==this.topLeft?this:(this.boundary(),0==this.topLeft.x&&0==this.topLeft.y?this:(this.attr("transform","translate("+-1*this.topLeft.x+", "+-1*this.topLeft.y+")"),this))},N.prototype.attr=function(t,r){return arguments.length>2&&void 0!==arguments[2]&&arguments[2]?this.attributes.set(t,r):this.attributes.add(t,r),this},N.prototype.inject=function(t){for(var r=["points","paths","snippets"],i=0;i<r.length;i++){var e=r[i];for(var n in t[e])void 0===this[e][n]&&(this[e][n]=t[e][n].clone())}return this},N.prototype.units=function(t){return g(t,this.context.settings.units)},N.prototype.shorthand=function(){var t=!!this.context.settings.complete,r=!0===this.context.settings.paperless;return{sa:this.context.settings.complete&&this.context.settings.sa||0,measurements:this.context.settings.measurements||{},options:this.context.settings.options||{},store:this.context.store,points:this.points||{},paths:this.paths||{},snippets:this.snippets||{},macro:this.macroClosure(),units:this.unitsClosure(),utils:_,Point:this.Point,Path:this.Path,Snippet:this.Snippet,complete:t,paperless:r,debug:this.debugClosure()}};var D="0.25.0";function H(r){this.openGroups=[],this.freeId=0,this.body="",this.style="",this.script="",this.header="",this.footer="",this.defs="",this.pattern=r,this.prefix='<?xml version="1.0" encoding="UTF-8" standalone="no"?>',this.attributes=new t,this.attributes.add("xmlns","http://www.w3.org/2000/svg"),this.attributes.add("xmlns:svg","http://www.w3.org/2000/svg"),this.attributes.add("xmlns:xlink","http://www.w3.org/1999/xlink"),this.attributes.add("xml:lang",r.settings.locale),this.attributes.add("xmlns:freesewing","http://freesewing.org/namespaces/freesewing"),this.attributes.add("freesewing",D)}H.prototype.runHooks=function(t){var r=arguments.length>1&&void 0!==arguments[1]&&arguments[1];!1===r&&(r=this);var i=this.hooks[t];if(i.length>0){var e=!0,n=!1,o=void 0;try{for(var s,a=i[Symbol.iterator]();!(e=(s=a.next()).done);e=!0){var h=s.value;h.method(r,h.data)}}catch(t){n=!0,o=t}finally{try{!e&&a.return&&a.return()}finally{if(n)throw o}}}},H.prototype.insertText=function(t){if(this.hooks.insertText.length>0){var r=!0,i=!1,e=void 0;try{for(var n,o=this.hooks.insertText[Symbol.iterator]();!(r=(n=o.next()).done);r=!0){var s=n.value;t=s.method(this.pattern.settings.locale,t,s.data)}}catch(t){i=!0,e=t}finally{try{!r&&o.return&&o.return()}finally{if(i)throw e}}}return t},H.prototype.debug=function(){},H.prototype.render=function(t){for(var r in this.idPrefix=t.settings.idPrefix,this.runHooks("preRender"),t.settings.embed||(this.attributes.add("width",t.width+"mm"),this.attributes.add("height",t.height+"mm")),this.attributes.add("viewBox","0 0 "+t.width+" "+t.height),this.svg=this.prefix,this.svg+=this.renderComments(this.header),this.svg+=this.renderSvgTag(t),this.svg+=this.renderStyle(),this.svg+=this.renderScript(),this.svg+=this.renderDefs(),this.svg+=this.openGroup(this.idPrefix+"container"),t.parts){var i=t.parts[r];i.render&&t.needs(r)&&(this.svg+=this.openGroup(this.idPrefix+"part-"+r,i.attributes),this.svg+=this.renderPart(i),this.svg+=this.closeGroup())}return this.svg+=this.closeGroup(),this.svg+=this.nl()+"</svg>",this.svg+=this.renderComments(this.footer),this.runHooks("postRender"),this.svg},H.prototype.renderSvgTag=function(t){var r="<svg";return this.indent(),r+=this.nl()+this.attributes.render(),this.outdent(),r+=this.nl()+">"+this.nl()},H.prototype.renderStyle=function(){var t='<style type="text/css"> <![CDATA[ ';return this.indent(),t+=this.nl()+this.style,this.outdent(),t+=this.nl()+"]]>"+this.nl()+"</style>"+this.nl()},H.prototype.renderScript=function(){var t='<script type="text/javascript"> <![CDATA[';return this.indent(),t+=this.nl()+this.script,this.outdent(),t+=this.nl()+"]]>"+this.nl()+"<\/script>"+this.nl()},H.prototype.renderDefs=function(){var t="<defs>";return this.indent(),t+=this.nl()+this.defs,this.outdent(),t+=this.nl()+"</defs>"+this.nl()},H.prototype.renderComments=function(t){return this.nl()+this.nl()+"\x3c!--"+this.nl()+t+this.nl()+"--\x3e"},H.prototype.renderPart=function(t){var r="";for(var i in t.paths){var e=t.paths[i];e.render&&(r+=this.renderPath(e))}for(var n in t.points)t.points[n].attributes.get("data-text")&&(r+=this.renderText(t.points[n])),t.points[n].attributes.get("data-circle")&&(r+=this.renderCircle(t.points[n]));for(var o in t.snippets){var s=t.snippets[o];r+=this.renderSnippet(s,t)}return r},H.prototype.renderPath=function(t){return t.attributes.get("id")||t.attributes.add("id",this.idPrefix+this.getId()),t.attributes.set("d",t.asPathstring()),this.nl()+"<path "+t.attributes.render()+" />"+this.renderPathText(t)},H.prototype.renderPathText=function(t){var r=t.attributes.get("data-text");if(!r)return"";this.text=this.insertText(r);var i=t.attributes.renderIfPrefixIs("data-text-"),e="",n=t.attributes.get("data-text-class");n&&n.indexOf("center")>-1?e=' startOffset="50%" ':n&&n.indexOf("right")>-1&&(e=' startOffset="100%" ');var o=this.nl()+"<text>";return this.indent(),o+='<textPath xlink:href="#'+t.attributes.get("id")+'" '+e+"><tspan "+i+">"+this.text+"</tspan></textPath>",this.outdent(),o+=this.nl()+"</text>"},H.prototype.renderText=function(t){var r=t.attributes.getAsArray("data-text");if(!1!==r){var i="",e=!0,n=!1,o=void 0;try{for(var s,a=r[Symbol.iterator]();!(e=(s=a.next()).done);e=!0){var h=s.value;this.text=this.insertText(h),i+=this.text+" "}}catch(t){n=!0,o=t}finally{try{!e&&a.return&&a.return()}finally{if(n)throw o}}this.text=this.insertText(i)}t.attributes.set("data-text-x",t.x),t.attributes.set("data-text-y",t.y);var p=t.attributes.get("data-text-lineheight")||12;t.attributes.remove("data-text-lineheight");var u=this.nl()+"<text "+t.attributes.renderIfPrefixIs("data-text-")+">";if(this.indent(),-1!==this.text.indexOf("\n")){var f=this.text.split("\n");u+="<tspan>"+f.shift()+"</tspan>";var y=!0,c=!1,l=void 0;try{for(var v,d=f[Symbol.iterator]();!(y=(v=d.next()).done);y=!0){var x=v.value;u+='<tspan x="'+t.x+'" dy="'+p+'">'+x+"</tspan>"}}catch(t){c=!0,l=t}finally{try{!y&&d.return&&d.return()}finally{if(c)throw l}}}else u+="<tspan>"+this.text+"</tspan>";return this.outdent(),u+=this.nl()+"</text>"},H.prototype.renderCircle=function(t){return'<circle\n    cx="'+t.x+'"\n    cy="'+t.y+'"\n    r="'+t.attributes.get("data-circle")+'"\n    '+t.attributes.renderIfPrefixIs("data-circle-")+"\n  ></circle>"},H.prototype.renderSnippet=function(t,r){var i=t.anchor.x,e=t.anchor.y,n=t.attributes.get("data-scale");n&&(t.attributes.add("transform","translate("+i+", "+e+")"),t.attributes.add("transform","scale("+n+")"),t.attributes.add("transform","translate("+-1*i+", "+-1*e+")"));var o=t.attributes.get("data-rotate");o&&t.attributes.add("transform","rotate("+o+", "+i+", "+e+")");var s=this.nl();return s+='<use x="'+i+'" y="'+e+'" ',s+='xlink:href="#'+t.def+'" '+t.attributes.render()+">",s+="</use>"},H.prototype.openGroup=function(t){var r=arguments.length>1&&void 0!==arguments[1]&&arguments[1],i=this.nl()+this.nl();return i+="\x3c!-- Start of group #"+t+" --\x3e",i+=this.nl(),i+='<g id="'+t+'"',r&&(i+=" "+r.render()),i+=">",this.indent(),this.openGroups.push(t),i},H.prototype.closeGroup=function(){return this.outdent(),this.nl()+"</g>"+this.nl()+"\x3c!-- end of group #"+this.openGroups.pop()+" --\x3e"},H.prototype.nl=function(){return"\n"+this.tab()},H.prototype.tab=function(){for(var t="",r=0;r<this.tabs;r++)t+="  ";return t},H.prototype.indent=function(){this.tabs+=1},H.prototype.outdent=function(){this.tabs-=1},H.prototype.getId=function(){return this.freeId+=1,""+this.freeId};var F=function(){};F.prototype={fit:function(t){var r,i,e,n,o=t.length,s=o>0?t[0].width:0,a=o>0?t[0].height:0;for(this.root={x:0,y:0,width:s,height:a},r=0;r<o;r++)e=t[r],(i=this.findNode(this.root,e.width,e.height))?(n=this.splitNode(i,e.width,e.height),e.x=n.x,e.y=n.y):(n=this.growNode(e.width,e.height),e.x=n.x,e.y=n.y)},findNode:function(t,r,i){return t.used?this.findNode(t.right,r,i)||this.findNode(t.down,r,i):r<=t.width&&i<=t.height?t:null},splitNode:function(t,r,i){return t.used=!0,t.down={x:t.x,y:t.y+i,width:t.width,height:t.height-i},t.right={x:t.x+r,y:t.y,width:t.width-r,height:i},t},growNode:function(t,r){var i=t<=this.root.width,e=r<=this.root.height,n=e&&this.root.height>=this.root.width+t,o=i&&this.root.width>=this.root.height+r;return n?this.growRight(t,r):o?this.growDown(t,r):e?this.growRight(t,r):i?this.growDown(t,r):null},growRight:function(t,r){var i;return this.root={used:!0,x:0,y:0,width:this.root.width+t,height:this.root.height,down:this.root,right:{x:this.root.width,y:0,width:t,height:this.root.height}},(i=this.findNode(this.root,t,r))?this.splitNode(i,t,r):null},growDown:function(t,r){var i;return this.root={used:!0,x:0,y:0,width:this.root.width,height:this.root.height+r,down:{x:0,y:this.root.height,width:this.root.width,height:r},right:this.root},(i=this.findNode(this.root,t,r))?this.splitNode(i,t,r):null}};var G=F;function q(){this.data=new Map}function U(){var i=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{options:{}};for(var e in this.config=i,this.width=!1,this.height=!1,this.is="",this.store=new q,this.parts={},this.hooks=E,this.Point=r,this.Path=R,this.Snippet=C,this.Attributes=t,this.settings={complete:!0,idPrefix:"fs-",locale:"en",units:"metric",margin:2,options:{}},void 0===this.config.inject&&(this.config.inject=[]),void 0===this.config.dependencies&&(this.config.dependencies={}),void 0===this.config.hide&&(this.config.hide=[]),this.config.resolvedDependencies=this.resolveDependencies(this.config.dependencies),this.config.draftOrder=this.draftOrder(this.config.resolvedDependencies),i.options){var n=i.options[e];if("object"===(void 0===n?"undefined":M(n)))if(void 0!==n.pct)this.settings.options[e]=n.pct/100;else if(void 0!==n.mm)this.settings.options[e]=n.mm;else if(void 0!==n.deg)this.settings.options[e]=n.deg;else if(void 0!==n.count)this.settings.options[e]=n.count;else{if(void 0===n.dflt)throw"Unknown option type";this.settings.options[e]=n.dflt}else this.settings.options[e]=n}this.macros={};var o={parts:this.parts,config:this.config,settings:this.settings,store:this.store,macros:this.macros};this.Part=function(){var t=new N;for(var r in t.context=o,o.macros)t[y(r)]=o.macros[r];return t}}return q.prototype.set=function(t,r){this.data.set(t,r)},q.prototype.setIfUnset=function(t,r){this.data.has(t)||this.data.set(t,r)},q.prototype.get=function(t){return this.data.get(t)},U.prototype.mergeSettings=function(t){var r=!0,i=!1,e=void 0;try{for(var n,o=Object.keys(t)[Symbol.iterator]();!(r=(n=o.next()).done);r=!0){var s=n.value;if(Array.isArray(t[s]))if(Array.isArray(this.settings[s])){var a=!0,h=!1,p=void 0;try{for(var u,f=t[s][Symbol.iterator]();!(a=(u=f.next()).done);a=!0){var y=u.value;this.settings[s].push(y)}}catch(t){h=!0,p=t}finally{try{!a&&f.return&&f.return()}finally{if(h)throw p}}}else this.settings[s]=t[s];else"object"===M(t[s])?this.settings[s]=k({},this.settings[s],t[s]):this.settings[s]=t[s]}}catch(t){i=!0,e=t}finally{try{!r&&o.return&&o.return()}finally{if(i)throw e}}},U.prototype.runHooks=function(t){var r=arguments.length>1&&void 0!==arguments[1]&&arguments[1];!1===r&&(r=this);var i=this.hooks[t];if(i.length>0){var e=!0,n=!1,o=void 0;try{for(var s,a=i[Symbol.iterator]();!(e=(s=a.next()).done);e=!0){var h=s.value;h.method(r,h.data)}}catch(t){n=!0,o=t}finally{try{!e&&a.return&&a.return()}finally{if(n)throw o}}}},U.prototype.draft=function(){"sample"!==this.is&&(this.is="draft"),this.runHooks("preDraft");var t=!0,r=!1,i=void 0;try{for(var e,n=this.config.draftOrder[Symbol.iterator]();!(t=(e=n.next()).done);t=!0){var o=e.value;if(this.parts[o]=new this.Part,"string"==typeof this.config.inject[o]&&this.parts[o].inject(this.parts[this.config.inject[o]]),this.needs(o)){var s="draft"+f(o);if("function"!=typeof this[s])throw new Error('Method "'+s+'" on pattern object is not callable');this.parts[o]=this[s](this.parts[o]),this.parts[o].render=this.wants(o)}}}catch(t){r=!0,i=t}finally{try{!t&&n.return&&n.return()}finally{if(r)throw i}}return this.runHooks("postDraft"),this},U.prototype.sample=function(){return"option"===this.settings.sample.type?this.sampleOption(this.settings.sample.option):"measurement"===this.settings.sample.type?this.sampleMeasurement(this.settings.sample.measurement):"models"===this.settings.sample.type?this.sampleModels(this.settings.sample.models,this.settings.sample.focus||!1):void 0},U.prototype.sampleParts=function(){var t={};for(var r in this.settings.complete=!1,this.settings.paperless=!1,this.draft(),this.parts)t[r]=new this.Part,t[r].render=this.parts[r].render;return t},U.prototype.sampleRun=function(t,r,i,e){var n=arguments.length>4&&void 0!==arguments[4]&&arguments[4];for(var o in this.draft(),this.parts){var s=0,a=0;for(var h in this.parts[o].points.anchor&&(void 0===r[o]?r[o]=this.parts[o].points.anchor:r[o].sitsOn(this.parts[o].points.anchor)||(s=this.parts[o].points.anchor.dx(r[o]),a=this.parts[o].points.anchor.dy(r[o]))),this.parts[o].paths)t[o].paths[h+"_"+i]=this.parts[o].paths[h].clone().attr("style",O(i,e)),this.parts[o].points.anchor&&(t[o].paths[h+"_"+i]=t[o].paths[h+"_"+i].translate(s,a)),!1!==n&&t[o].paths[h+"_"+i].attributes.add("class",n)}},U.prototype.sampleOption=function(t){this.is="sample",this.runHooks("preSample");var r,i=void 0,e=1,n={},o=this.sampleParts(),s=this.config.options[t];if("object"===M(s.list))return this.sampleListOption(t);void 0!==s.min&&void 0!==s.max||(s={min:.9*s,max:1.1*s});void 0!==s.pct&&(e=100),i=s.min/e,r=(s.max/e-i)/9;for(var a=1;a<11;a++)this.settings.options[t]=i,this.debug({type:"info",label:"🏃🏿‍♀️ Sample run",msg:"Sampling option "+t+" with value "+S(i)}),this.sampleRun(o,n,a,10),i+=r;return this.parts=o,this.runHooks("postSample"),this},U.prototype.sampleListOption=function(t){var r=this.sampleParts(),i=this.config.options[t],e={},n=1,o=i.list.length,s=!0,a=!1,h=void 0;try{for(var p,u=i.list[Symbol.iterator]();!(s=(p=u.next()).done);s=!0){var f=p.value;this.settings.options[t]=f,this.debug({type:"info",label:"🏃🏿‍♀️ Sample run",msg:"Sampling option "+t+" with value "+S(f)}),this.sampleRun(r,e,n,o),n++}}catch(t){a=!0,h=t}finally{try{!s&&u.return&&u.return()}finally{if(a)throw h}}return this.parts=r,this},U.prototype.sampleMeasurement=function(t){this.is="sample",this.runHooks("preSample");var r={},i=this.sampleParts(),e=this.settings.measurements[t];if(void 0===e)throw"Cannot sample a measurement that is undefined";var n=e/50;e*=.9;for(var o=1;o<11;o++)this.settings.measurements[t]=e,this.debug({type:"info",label:"🏃🏿‍♀️ Sample run",msg:"Sampling option "+t+" with value "+S(e)}),this.sampleRun(i,r,o,10),e+=n;return this.parts=i,this.runHooks("postSample"),this},U.prototype.sampleModels=function(t){var r=arguments.length>1&&void 0!==arguments[1]&&arguments[1];this.is="sample",this.runHooks("preSample");var i={},e=this.sampleParts(),n=0,o=Object.keys(t).length;for(var s in t){n++,this.settings.measurements=t[s],this.debug({type:"info",label:"🏃🏿‍♀️ Sample run",msg:"Sampling model "+s});var a=s===r?"sample-focus":"";this.sampleRun(e,i,n,o,a)}return this.parts=e,this.runHooks("postSample"),this},U.prototype.debug=function(t){this.runHooks("debug",t)},U.prototype.render=function(){return this.svg=new H(this),this.svg.hooks=this.hooks,this.pack().svg.render(this)},U.prototype.on=function(t,r,i){this.hooks[t].push({method:r,data:i})},U.prototype.use=function(t){var r=arguments.length>1&&void 0!==arguments[1]&&arguments[1];return this.debug({type:"success",label:"🔌 Plugin loaded",msg:t.name+" v"+t.version}),t.hooks&&this.loadPluginHooks(t,r),t.macros&&this.loadPluginMacros(t),this},U.prototype.loadPluginHooks=function(t,r){var i=!0,e=!1,n=void 0;try{for(var o,s=Object.keys(this.hooks)[Symbol.iterator]();!(i=(o=s.next()).done);i=!0){var a=o.value;if("function"==typeof t.hooks[a])this.on(a,t.hooks[a],r);else if(Array.isArray(t.hooks[a])){var h=!0,p=!1,u=void 0;try{for(var f,y=t.hooks[a][Symbol.iterator]();!(h=(f=y.next()).done);h=!0){var c=f.value;this.on(a,c,r)}}catch(t){p=!0,u=t}finally{try{!h&&y.return&&y.return()}finally{if(p)throw u}}}}}catch(t){e=!0,n=t}finally{try{!i&&s.return&&s.return()}finally{if(e)throw n}}},U.prototype.loadPluginMacros=function(t){for(var r in t.macros)"function"==typeof t.macros[r]&&this.macro(r,t.macros[r])},U.prototype.macro=function(t,r){this.macros[t]=r},U.prototype.pack=function(){var t=[];for(var r in this.parts){var i=this.parts[r];i.attributes.set("transform",""),i.render&&this.needs(r)&&(i.stack(),t.push({id:r,width:i.bottomRight.x-i.topLeft.x,height:i.bottomRight.y-i.topLeft.y}))}var e=function(t,r){r=r||{};var i=new G,e=r.inPlace||!1,n=t.map(function(t){return e?t:{width:t.width,height:t.height,item:t}});n=n.sort(function(t,r){return r.width*r.height-t.width*t.height}),i.fit(n);var o={width:n.reduce(function(t,r){return Math.max(t,r.x+r.width)},0),height:n.reduce(function(t,r){return Math.max(t,r.y+r.height)},0)};return e||(o.items=n),o}(t,{inPlace:!0}),n=!0,o=!1,s=void 0;try{for(var a,h=t[Symbol.iterator]();!(n=(a=h.next()).done);n=!0){var p=a.value,u=this.parts[p.id];0===p.x&&0===p.y||u.attr("transform","translate ("+p.x+", "+p.y+")")}}catch(t){o=!0,s=t}finally{try{!n&&h.return&&h.return()}finally{if(o)throw s}}return this.width=e.width,this.height=e.height,this},U.prototype.draftOrder=function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:this.resolveDependencies(),r=[],i={};return Object.keys(t).forEach(function e(n,o){Array.isArray(o)||(o=[]),o.push(n),i[n]=!0,void 0!==t[n]&&t[n].forEach(function(t){i[t]||e(t,o.slice(0))}),r.indexOf(n)<0&&r.push(n)}),r},U.prototype.resolveDependency=function(t,r){var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:this.config.dependencies,e=arguments.length>3&&void 0!==arguments[3]?arguments[3]:[];if(void 0===t[r]&&(t[r]=!0),"string"==typeof i[r])return e.push(i[r]),this.resolveDependency(t,i[r],i,e);if(Array.isArray(i[r])){if(0===i[r].length)return[];0===e.length&&(e=i[r]);var n=!0,o=!1,s=void 0;try{for(var a,h=i[r][Symbol.iterator]();!(n=(a=h.next()).done);n=!0){var p=a.value;e.concat(this.resolveDependency(t,p,i,e))}}catch(t){o=!0,s=t}finally{try{!n&&h.return&&h.return()}finally{if(o)throw s}}}return e},U.prototype.resolveDependencies=function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:this.config.dependencies;if(Array.isArray(this.config.parts)){var r=!0,i=!1,e=void 0;try{for(var n,o=this.config.parts[Symbol.iterator]();!(r=(n=o.next()).done);r=!0){var s=n.value;void 0===this.config.dependencies[s]&&(this.config.dependencies[s]=[])}}catch(t){i=!0,e=t}finally{try{!r&&o.return&&o.return()}finally{if(i)throw e}}}var a={},h={},p=!0,u=!1,f=void 0;try{for(var y,c=Object.keys(t)[Symbol.iterator]();!(p=(y=c.next()).done);p=!0){var l=y.value;a[l]=this.resolveDependency(h,l,t)}}catch(t){u=!0,f=t}finally{try{!p&&c.return&&c.return()}finally{if(u)throw f}}var v=!0,d=!1,x=void 0;try{for(var g,m=Object.keys(h)[Symbol.iterator]();!(v=(g=m.next()).done);v=!0){var b=g.value;void 0===a[b]&&(a[b]=[])}}catch(t){d=!0,x=t}finally{try{!v&&m.return&&m.return()}finally{if(d)throw x}}return a},U.prototype.needs=function(t){if(void 0===this.settings.only||!1===this.settings.only)return!0;if("string"==typeof this.settings.only){if(this.settings.only===t)return!0;if(Array.isArray(this.config.resolvedDependencies[this.settings.only])){var r=!0,i=!1,e=void 0;try{for(var n,o=this.config.resolvedDependencies[this.settings.only][Symbol.iterator]();!(r=(n=o.next()).done);r=!0){if(n.value===t)return!0}}catch(t){i=!0,e=t}finally{try{!r&&o.return&&o.return()}finally{if(i)throw e}}}}else if(Array.isArray(this.settings.only)){var s=!0,a=!1,h=void 0;try{for(var p,u=this.settings.only[Symbol.iterator]();!(s=(p=u.next()).done);s=!0){var f=p.value;if(f===t)return!0;var y=!0,c=!1,l=void 0;try{for(var v,d=this.config.resolvedDependencies[f][Symbol.iterator]();!(y=(v=d.next()).done);y=!0){if(v.value===t)return!0}}catch(t){c=!0,l=t}finally{try{!y&&d.return&&d.return()}finally{if(c)throw l}}}}catch(t){a=!0,h=t}finally{try{!s&&u.return&&u.return()}finally{if(a)throw h}}}return!1},U.prototype.isHidden=function(t){return!(!Array.isArray(this.config.hide)||-1===this.config.hide.indexOf(t))},U.prototype.wants=function(t){if(void 0===this.settings.only||!1===this.settings.only){if(this.isHidden(t))return!1}else{if("string"==typeof this.settings.only)return this.settings.only===t;if(Array.isArray(this.settings.only)){var r=!0,i=!1,e=void 0;try{for(var n,o=this.settings.only[Symbol.iterator]();!(r=(n=o.next()).done);r=!0){if(n.value===t)return!0}}catch(t){i=!0,e=t}finally{try{!r&&o.return&&o.return()}finally{if(i)throw e}}return!1}}return!0},{version:D,Pattern:U,Point:r,Path:R,Snippet:C,utils:_,patterns:{},plugins:{}}}();
//# sourceMappingURL=browser.js.map
